#ifndef OSFUNCS_H
#define OSFUNCS_H

#include <bits/pthreadtypes.h>

int pthread_cond_init(pthread_cond_t    *cond,    pthread_condattr_t
		      *cond_attr);
int pthread_cond_signal(pthread_cond_t *cond);
int pthread_cond_wait(pthread_cond_t *cond, pthread_mutex_t *mutex);

int pthread_mutex_init(pthread_mutex_t  *mutex,  const  pthread_mutexattr_t *mutexattr);
int pthread_mutex_lock(pthread_mutex_t *mutex);
int pthread_mutex_unlock(pthread_mutex_t *mutex);

 int pthread_attr_init(pthread_attr_t *attr);
int pthread_attr_setdetachstate(pthread_attr_t *attr, int detachstate);
int  pthread_create(pthread_t  *  thread, pthread_attr_t * attr, void *
		    (*start_routine)(void *), void * arg);

void *calloc(size_t nmemb, size_t size);
void exit(int status);

unsigned int sleep(unsigned int seconds);

void abort(void);

extern void (*errorHandler)(char *file, int line, char *statement);
#define assert(statement) do { if(!(statement)) { errorHandler(__FILE__,__LINE__,#statement); } } while(0) 

#endif
