#include <stdarg.h>

#include "linux/kernel.h"
#include "linux/sched.h"

#include "osfuncs.h"

int vprintf(const char *format, va_list ap);
int vsprintf(char *str, const char *format, va_list ap);
int vsnprintf(char *str, size_t size, const char *format, va_list ap);
int printf(const char *format, ...);

void exit(int status);
#define not_implemented() printf("%s not implemented\n",__FUNCTION__); abort();


asmlinkage int printk(const char *fmt, ...)
{
  	va_list args;
	int r;

	va_start(args, fmt);
	r = vprintf(fmt, args);
	va_end(args);

	return r;

}

void __print_symbol()
{
}

void preempt_schedule() { not_implemented(); }

int __const_udelay;
struct task_struct init_task;
task_t fastcall *next_thread(const task_t *p) { not_implemented(); }
struct semaphore kernel_sem;

int console_printk[4] = { 0,0,0,0 };


void dump_stack() 
{ 
  printf("dumping stack here...\n");
}
void show_stack(struct task_struct *task, unsigned long *sp) 
{ 
  printf("showin stack here...\n");
}
int normal_prio(task_t *p)  { not_implemented(); }
void __WARN_ON(const char *func, const char *file, const int line)
{
  printf("WARN_ON: %s:%d : %s\n",file,line,func);
}


void rcu_read_lock() { not_implemented(); }
void rcu_read_unlock() { not_implemented(); }
void fastcall call_rcu_bh(struct rcu_head *head,
			  void (*func)(struct rcu_head *head))
{ not_implemented(); }
struct task_struct *find_task_by_pid_type(int type, int pid)
 { not_implemented(); }
void __put_task_struct_cb(struct rcu_head *rhp) { not_implemented(); }

unsigned long volatile __jiffy_data jiffies;

void fastcall init_timer(struct timer_list * timer) { not_implemented(); }
int del_timer(struct timer_list * timer) { not_implemented(); }
int __mod_timer(struct timer_list *timer, unsigned long expires)  { not_implemented(); }
int del_timer_sync(struct timer_list *timer) { not_implemented(); }

long int irqflags;

struct thread_info * const current_ti;
struct task_struct * const ___current;

#ifdef CONFIG_LATENCY_TRACE
void notrace trace_special_pid(int pid, unsigned long v1, unsigned long v2)
{
}
void notrace trace_special(unsigned long v1, unsigned long v2, unsigned long v3){
} 
#endif
