#ifndef TESTFILE_H
#define TESTFILE_H

#define MAX_TASKS 10
#define MAX_LOCKS 10

typedef enum taskjob_e 
  { 
    IDLE, 
    RUNNING, 
    TLOCK, 
    TLOCK_INTR,
    UNLOCK,
    SPIN_LOCK, 
    SPIN_UNLOCK, 
    SIGNAL,
    SETSTATE 
  } taskjob_e;

typedef struct taskjob
{
  taskjob_e id;  
  union {
    int lock;
    int thread;
    int state;
  } data;
  int done;
} taskjob_t;
 

typedef enum test_e
  {
    NOTEST,
    BLOCKED,
    NONBLOCKED,
    PRIORITY,
    STATE,
    LOCKCOUNT
  } test_e;

typedef struct test
{
  test_e id;
  union {
    int priority;
    int state;
    int lock_count;
  } data;
} test_t;

typedef struct testentry
{
  int line;
  test_t tests[MAX_TASKS];
  struct testentry *next;
} testentry_t;


typedef struct timeentry
{
  int line;
  taskjob_t jobs[MAX_TASKS];
  int timeout;
  testentry_t *tests;
  struct timeentry *next;
} timeentry_t;

void read_testfile(char *filename);

extern int nthreads;

extern int priorities[MAX_TASKS];
extern timeentry_t *first_time;

#endif
